import sqlite3
import struct
import socket

class EventDB:

    def __init__(self, dbFilename = 'events.sqlite'):
        self._db = sqlite3.connect(dbFilename)

    def __del__(self):
        self._db.commit()

    def addEvent(self, ipAddr, count = 1):
        cursor = self._db.cursor()

        ipNum = EventDB.ip_to_int(ipAddr)
        cursor.execute('INSERT INTO events (ipNum, count) VALUES (?, ?)',
            (ipNum, count))

    def clean(self):
        cursor = self._db.cursor()
        cursor.execute('DELETE FROM events')
        cursor.execute('VACUUM')

    # FIXME: Do some error checking here.
    @staticmethod
    def int_to_ip(ip_num):
        return socket.inet_ntoa(struct.pack('I', ip_num))

    # FIXME: Do some error checking here.
    @staticmethod
    def ip_to_int(ip_string):
        return struct.unpack('I', socket.inet_aton(ip_string))[0]
